#include "windows.bi"

#include once "fbdoc_defs.bi"
#include once "CWikiCon.bi"

#include "resource.bi"

using fb
using fbdoc

extern wikicon as CWikiCon ptr

type LONGINDLG
	user	as zstring * 32
	pwd		as zstring * 32
end type

function logindlg_cb (byval hwndDlg as HWND, byval umsg as UINT, byval wParam as WPARAM, byval lParam as LPARAM) as BOOL
    dim as long id, event
    static as LONGINDLG ptr contents
    
    select case uMsg
    case WM_INITDIALOG
    	contents = cast( LONGINDLG ptr, lparam )
    	SendMessage( GetDlgItem( hwndDlg, IDC_LOGINDLG_USER ), WM_SETTEXT, 0, cast( LPARAM, @contents->user ) )
    	SendMessage( GetDlgItem( hwndDlg, IDC_LOGINDLG_PWD ), WM_SETTEXT, 0, cast( LPARAM, @contents->pwd ) )

    case WM_CLOSE
    	SendMessage( GetDlgItem( hwndDlg, IDC_LOGINDLG_USER ), WM_GETTEXT, sizeof( contents->user ), cast( LPARAM, @contents->user ) )
    	SendMessage( GetDlgItem( hwndDlg, IDC_LOGINDLG_PWD ), WM_GETTEXT, sizeof( contents->pwd ), cast( LPARAM, @contents->pwd ) )
    	EndDialog( hwndDlg, FALSE )

    case WM_COMMAND
		id    = loword( wParam )
		event = hiword( wParam )

        select case id
        case IDC_LOGINDLG_OK
    		SendMessage( GetDlgItem( hwndDlg, IDC_LOGINDLG_USER ), WM_GETTEXT, sizeof( contents->user ), cast( LPARAM, @contents->user ) )
    		SendMessage( GetDlgItem( hwndDlg, IDC_LOGINDLG_PWD ), WM_GETTEXT, sizeof( contents->pwd ), cast( LPARAM, @contents->pwd ) )
        	EndDialog( hwndDlg, TRUE )

        case IDC_LOGINDLG_CANCEL
        	EndDialog( hwndDlg, FALSE )
    	end select
        
    case else
    	return FALSE
    	
    end select
    
   return TRUE
   
end function 

function Connection_Login( byval hwnd as HWND ) as integer

	static as integer islogged = FALSE
	static as LONGINDLG contents
	
	if( wikicon = NULL ) then
		return FALSE
	end if
	
	if( islogged <> FALSE ) then
		return TRUE
	end if

	if( DialogBoxParam( GetModuleHandle( null ), _
						cast( LPCSTR, IDD_LOGINDLG ), _
						hwnd, _
						@logindlg_cb, _
						cast( LPARAM, @contents ) ) = FALSE ) then
		return FALSE
	end if
	
	print "Logging in...";
	
	islogged = wikicon->Login( contents.user, contents.pwd )

	if( islogged = FALSE ) then
		print "FAILED"
		return FALSE
	else
		print "OK"
	end if
	
	return TRUE

end function
